'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var request = require('../../ajax');

module.exports = requestWithBasicAuth;

function requestWithBasicAuth(data, done) {
  if (typeof data.basicAuth.username !== 'string' || typeof data.basicAuth.password !== 'string') {
    throw new TypeError('Username and password must be defined');
  }

  // Check we have a basic auth object before mixing in our credentials.
  if (data.basicAuth && _typeof(data.basicAuth) === 'object') {
    data.headers = Object.assign({
      Authorization: 'Basic ' + Buffer.from(data.basicAuth.username + ':' + data.basicAuth.password).toString('base64')
    }, data.headers);
  }

  return request(data, done);
}
//# sourceMappingURL=request.js.map