declare class API {
  /**
   * Generate an API client from a RAML document.
   *
   * @param {string} groupId
   * @param {string} assetId
   * @param {string} version
   * @param {any} config
   */
  static createClient(groupId: string, assetId: string, version: string, config?: { sync: boolean, baseUri: string }): any;

  /**
   * Generate an API client from a RAML document and alias it on the window.
   *
   * @param {string} name
   * @param {string} groupId
   * @param {string} assetId
   * @param {string} version
   * @param {any} config
   */
  static createClient(name: string, groupId: string, assetId: string, version: string, config?: { sync: boolean, baseUri: string }): any;

  /**
   * Generate an API client from a RAML document and alias it on the window.
   *
   * @param {string} url
   * @param {any} config
   */
  static createClient(name: string, url: string, config?: { sync: boolean, baseUri: string }): any;

  /**
   * Set a configuration option of a RAML API client.
   *
   * @param {any} client
   * @param {string} key
   * @param {any} value
   */
  static set(client: any, key: string, value: any): any;

  /**
   * Get a configuration option from a RAML API client.
   *
   * @param {any} client
   * @param {string} key
   */
  static get(client: any, key: string): any;

  /**
   * Authenticate a RAML API client with credentials.
   *
   * @param {any} client
   * @param {string} method
   * @param {any} options
   */
  static authenticate(client: any, method: string, options?: any): any;
}
