const bodyParser = require('body-parser');
const express = require('express');

let server;

before((done) => {
  const app = express();

  app.use(bodyParser.urlencoded({ extended: true }));

  app.get('/v2/content', (req, res) => {
    res.set('Content-type', 'application/json');
    res.send(`{"data":["${req.query.search}"]}`);
    res.end();
  });

  app.get('/v2/authorized', (req, res) => {
    res.set('Content-type', 'application/json');
    res.send(`{"header":"${req.headers.authorization.replace(/"/g, '\\"')}"}`);
    res.end();
  });

  app.post('/oauth2/access_token', (req, res) => {
    res.set('Content-type', 'application/json');
    res.send(`{"access_token":"my-token","token_type":"bearer","body":${JSON.stringify(req.body)}}`);
    res.end();
  });

  app.get('/content', (req, res) => {
    res.set('Content-type', 'application/json');
    res.send(`{"results":["${req.query.search}"]}`);
    res.end();
  });

  app.get('/authorized', (req, res) => {
    res.set('Content-type', 'application/json');
    res.send(`{"header":"${req.headers.authorization}"}`);
    res.end();
  });

  app.get('*', (req, res) => {
    res.status(404);
    res.send('Not found');
  });

  // eslint-disable-next-line no-unused-vars
  app.use((err, req, res, next) => {
    // eslint-disable-next-line no-console
    console.error(err);
    res.status(500);
    res.send('An error occurred');
    res.end();
  });

  server = app.listen(5001, () => {
    done();
  });
});

after(() => {
  server.close();
});
